package service

import (
	"errors"

    "github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
	cDto "go-admin/common/dto"
)

type LineRecharge struct {
	service.Service
}

// GetPage 获取LineRecharge列表
func (e *LineRecharge) GetPage(c *dto.LineRechargeGetPageReq, p *actions.DataPermission, list *[]models.LineRecharge, count *int64) error {
	var err error
	var data models.LineRecharge

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("LineRechargeService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取LineRecharge对象
func (e *LineRecharge) Get(d *dto.LineRechargeGetReq, p *actions.DataPermission, model *models.LineRecharge) error {
	var data models.LineRecharge

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetLineRecharge error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建LineRecharge对象
func (e *LineRecharge) Insert(c *dto.LineRechargeInsertReq) error {
    var err error
    var data models.LineRecharge
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("LineRechargeService Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改LineRecharge对象
func (e *LineRecharge) Update(c *dto.LineRechargeUpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.LineRecharge{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if err = db.Error; err != nil {
        e.Log.Errorf("LineRechargeService Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除LineRecharge
func (e *LineRecharge) Remove(d *dto.LineRechargeDeleteReq, p *actions.DataPermission) error {
	var data models.LineRecharge

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service RemoveLineRecharge error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}
